CREATE OR REPLACE PROCEDURE REINF_R2098(
    P_CDEMPRESA      IN EMPRESA.CDEMPRESA%TYPE,
    P_NRENVIO        IN NUMBER,
    P_NREVENTO       IN NUMBER,
    P_DSVERSAO       IN VARCHAR2,
    P_IDAMBIENTE     IN VARCHAR2,
    P_DTMESCOMPETENC IN ENVIOEVENTOREINF.DTMESCOMPETENC%TYPE )
    
    
AS
   V_NRSEQREINF      NUMBER;
   V_DTCOMPSEMMOVTO  VARCHAR2(7);
   V_COUNT           NUMBER;
BEGIN
   V_COUNT:= 0;
   BEGIN
     SELECT TO_CHAR(DTCOMPSEMMOVTO,'YYYY-MM')
       INTO V_DTCOMPSEMMOVTO
       FROM ENVIOEVENTOREINF
      WHERE NRENVIO = (SELECT MAX(NRENVIO)
                         FROM ENVIOEVENTOREINF
                        WHERE CDEMPRESA      = P_CDEMPRESA
                          AND IDSTATUS       <> 'P'  -- No considera eventos que ainda no foram enviados
                          AND NREVENTO       = P_NREVENTO
                          AND DTMESCOMPETENC = ADD_MONTHS(P_DTMESCOMPETENC,-1) );
   EXCEPTION
   WHEN NO_DATA_FOUND THEN
      V_DTCOMPSEMMOVTO := NULL;
   END;


   /* BUSCA  AS INFORMAES PARA A REABERTURA DO  FECHAMENTO DE EVENTOS*/
   FOR C_2098 IN (SELECT TO_CHAR(TO_DATE(P_DTMESCOMPETENC),'YYYY-MM')                               AS PERAPUR,
                         P_IDAMBIENTE                                                               AS TMPAMB,
                         '1'                                                                        AS PROCEMI ,
                         '1.5.1'                                                                    AS VERPROC,
                         DECODE(E.IDTPIJUREMPR,'J','1','F','2',' ')                                 AS TPINSC,
                         DECODE(E.IDTPIJUREMPR,'J',SUBSTR(E.NRINSJUREMPR,1,8), 'F', E.NRINSJUREMPR) AS NRINSC
                    FROM EMPRESA E
                   WHERE E.CDEMPRESA = P_CDEMPRESA) LOOP

                  NOVO_CODIGO_NT('NRSEQREINF', V_NRSEQREINF);
                  INSERT INTO ARQEFD_REINF
                         ( CDEMPRESA, NREVENTO, NRENVIO, CDCAMPO1, CDCAMPO2,
                           CDCAMPO3, CDCAMPO4, CDCAMPO5, CDCAMPO6, NRSEQREINF)

                  VALUES ( P_CDEMPRESA, P_NREVENTO, P_NRENVIO, C_2098.PERAPUR, C_2098.TMPAMB,
                           C_2098.PROCEMI , C_2098.VERPROC, C_2098.TPINSC, C_2098.NRINSC, V_NRSEQREINF );
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('REINF_R2098','5.85.xxx'); END;
/
